// AUTOGENERATED FILE - DO NOT MODIFY!
// This file generated by Djinni from AccessibilityManager.djinni

#pragma once

#include <memory>

namespace verifone_sdk {

class AccessibilityListener;

class AccessibilityManager {
public:
    virtual ~AccessibilityManager() {}

    /** Set listener to receive events */
    virtual void setListener(const std::shared_ptr<AccessibilityListener> & listener) = 0;

    /**
     * Requests the current mode the terminal is in at the moment
     * Terminal will respond to this request with current mode
     */
    virtual bool retrieveMode() = 0;

    /** request a mode change to accessibility */
    virtual bool enableAccessibilityMode() = 0;

    /** request a mode change to assistance */
    virtual bool enableAssistanceMode() = 0;

    /** request a mode change to standard */
    virtual bool returnToStandardMode() = 0;

    /** request a mode change to assistance and enable vocalization */
    virtual bool enableVoice() = 0;

    /** request a mode change to assistance and disable vocalization */
    virtual bool disableVoice() = 0;

    /** request a mode change to assistance and enable color selection */
    virtual bool enableColorSelectionMode() = 0;

    /** request a mode change to training and start short training mode */
    virtual bool startShortTraining() = 0;

    /** request a mode change to training and start exploration training mode */
    virtual bool startExplorationTraining() = 0;

    /** request a mode change to training and start double tap training mode */
    virtual bool startDoubleTapTraining() = 0;

    /** request a mode change to training and start short edge mode */
    virtual bool startEdgesTraining() = 0;

    /** request a mode change to training and start navigation training mode */
    virtual bool startNavigationTraining() = 0;

    /** request a mode change to training and start submit digit training mode */
    virtual bool startSubmitDigitTraining() = 0;

    /** request a mode change to training and start enter pin training mode */
    virtual bool startEnterPinTraining() = 0;
};

}  // namespace verifone_sdk
